"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var MolliePlugin_1;
Object.defineProperty(exports, "__esModule", { value: true });
exports.MolliePlugin = void 0;
const core_1 = require("@vendure/core");
const mollie_controller_1 = require("./mollie.controller");
const mollie_handler_1 = require("./mollie.handler");
let MolliePlugin = MolliePlugin_1 = class MolliePlugin {
    /**
     * Initialize the mollie payment plugin
     * @param vendureHost is needed to pass to mollie for callback
     */
    static init(vendureHost) {
        this.host = vendureHost;
        return MolliePlugin_1;
    }
};
MolliePlugin.context = 'MolliePlugin';
MolliePlugin = MolliePlugin_1 = __decorate([
    core_1.VendurePlugin({
        imports: [core_1.PluginCommonModule],
        controllers: [mollie_controller_1.MollieController],
        configuration: (config) => {
            config.paymentOptions.paymentMethodHandlers.push(mollie_handler_1.molliePaymentHandler);
            return config;
        },
    })
], MolliePlugin);
exports.MolliePlugin = MolliePlugin;
